<?php

namespace jerryyan\staff\model;

use think\admin\Model;
use think\db\Query;
use think\model\relation\HasOne;

class StaffUser extends Model
{
    protected $createTime = 'create_at';
    protected $updateTime = false;
    protected $oplogName = '部门员工';
    protected $oplogType = '部门员工管理';
    protected $globalScope = ['notDeleted'];

    public function scopeDeleted(Query $query): void
    {
        $query->where('is_deleted', '=', 1);
    }

    public function scopeNotDeleted(Query $query): void
    {
        $query->where('is_deleted', '=', 0);
    }

    public function dept(): HasOne
    {
        return $this->hasOne(StaffDept::class, 'id', 'dept_id')->where([
            'status' => 1, 'is_deleted' => 0,
        ]);
    }

    public function getDeptNameAttr($value, $data)
    {
        return $this->dept ? $this->dept['name'] : '';
    }
}